//+------------------------------------------------------------------+
//|                        VolatilyScalp                             |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Volatily-Scalp.blogspot.com"
#property link      "Volatily-Scalp.blogspot.com"

#import "volatily.dll"
        void calculateIndi(double ma[],double std[],double atr[]);
	     void setOrder(int type,int tickets[4], double openprice[4], double closeprice[4], int opentime[4], int total);
	     void setHarga(double bid, double ask, double spread, double point, int curtime,int period, double wpr,double normalsp,double target);
	     void setFilter(int tradeperbar, int maxtrade);
	     void setBuySell(int buy, int sell);
	     void setBuy(int buy);
	     void setSell(int sell);
	     void setBuy2(int buy);
	     void setSell2(int sell);
	     double executeOrder(int cmd);
	     int getTime();
	     void updateFilter();
	     int GetCloseCommand(double ht, double hl,double sp1, double sp2, int tradingtime);
	      double Getbid();
	     double TrailingStop(int cmd,double sp1,double sp2);
	     int GetTiket1();
	     int GetTiket2();
	     int GetTiket3();
	     int GetTiket4();
#import
extern  int VolatilyPeriod =20;
extern  double MyOwnTarget=10;
extern  bool isTrailing=true;
extern  string  MySpreadInfo="Just For Backtesting";
extern  bool    UseMySpread=false;
extern  double MySpread=4;
//--------TradingTime--------
extern  int       Magic     =   1514;
extern  string  Time_Info   = "Base on Server Time";
extern  int     OpenHour    = 22; 
extern  int     CloseHour   = 5;
extern  int     MondayStart = 2;
extern  bool    AllowBuy    =true;
extern  bool    AllowSell   =true;
extern  bool    MM        = true;
extern  bool    Marti_MM  = false;
extern  int    Margin    = 100;//100 % from balance, since d04
extern  int     Risk      = 50;  
extern  double  Lots      = 0.1; 
extern  int     LotsDigit   = 2;
extern  int     Slippage    = 3;
extern  int     StopLoss        = 60;
extern   double NormalSpread    =1000;//
extern  string  HedgeInfo  ="Since d03";
extern  bool    AllowHedge=true;
//-------D04 feature---------------------------------
extern  bool    UseAtrMod  =false;

//------------------------------------
extern string   Atr_Info   ="Read my manual before apply spesific filter";
extern  double  MaxDayAtr   =250;
//-------------------------------------
extern string   EquityInfo ="It is better to set amount target when running on multiple pair";
extern double   EquityTarget=0;
extern bool     SecureMyEquityTarget=false;
//----------------------------------------------------------------------------
extern  int     MaxTradePerPosition = 4;

extern  string  EAName  ="Volatily Scalp";
extern  string  Typical ="Sideway, counter trend system";
extern  string  Creator ="Ch1qho";
extern  string  Distribution="Donation";
extern  string  Version ="VS_EURCROSS D_04";
extern  string  Expired ="See in your chart window";
extern string   email_YM          = "ch1qho@yahoo.com";

//----------------------------------------------------------------------------
int            TradePerBar = 0;

//---------------------------------------------------------------------------- 





double diff=0;

double spread=0;
double mypoint=0.01;
double stoplevel=0;
int BarCount=0;
int bar60=0;
int bar1=0;
double arrma[101],arrstd[101],arratr[101];
int a=0;
int b=0;
int c=0;
//bool initarr=false;
int ot[4],buys[4],sells[4],ot2[4];
double opens2[4],closes2[4];
double closes[4];
double opens[4];
double VirtualStopBuy=0;
double VirtualStopSell=0;
/*
   debugging purpose to track exit strategies
*/
int case1,case11,case111,case1111,case11111,case111111,case110,case11110=0;
int case2,case22,case222,case2222,case22222,case222222,case220,case22220=0;
int case33,case44,case55,case66=0;
int case333,case444,case555,case666=0;
int case3333,case4444,case5555,case6666=0;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
   

   
   ArrayInitialize(arrma,0);
ArrayInitialize(arrstd,0);
ArrayInitialize(arratr,0);
BarCount=Bars-1;
if(AllowBuy)setBuy(1);else setBuy(0);
if(AllowSell)setSell(1);else setSell(0);
setBuy2(1);
setSell2(1);
setFilter(0,MaxTradePerPosition);
 a=getTime();

}


int deinit()
{
Print("case1:", case1,"case11:",case11,"case111:",case111,"case1111:",case1111,"case11111:",case11111,"case111111:",case111111,"case110:",case110,"case11110:",case11110);
//int case2,case22,case222,case2222,case22222,case222222,case220,case22220=0;
Print("case2:", case2,"case22:",case22,"case222:",case222,"case2222:",case2222,"case22222:",case22222,"case222222:",case222222,"case220:",case220,"case22220:",case22220);
Print("case33:", case33,"case44:",case44,"case55:",case55,"case66:",case66);
Print("case333:", case333,"case444:",case444,"case555:",case555,"case666:",case666);
Print("case3333:", case3333,"case4444:",case4444,"case5555:",case5555,"case6666:",case6666);

}
int start()
{


   if(Digits==3){
      mypoint=0.01;
      spread=MarketInfo(Symbol(),MODE_SPREAD)/10;
      stoplevel=MarketInfo(Symbol(),MODE_STOPLEVEL)/10;
   }else if(Digits==5){
      mypoint=0.0001;
      spread=MarketInfo(Symbol(),MODE_SPREAD)/10;
      stoplevel=MarketInfo(Symbol(),MODE_STOPLEVEL)/10;
   }else{
      mypoint=Point;
      spread=MarketInfo(Symbol(),MODE_SPREAD);
      stoplevel=MarketInfo(Symbol(),MODE_STOPLEVEL);
   }
   if(UseMySpread&&MySpread<spread) spread=MySpread;




if(GetLastError()>1)Sleep(1000);// May this delay help to run on multiple pair 
if(MaxTradePerPosition>4)MaxTradePerPosition=4;
double wpr1=iWPR(Symbol(),1,20,0);
if(Bars<101)return;

double dailyatr=iATR(Symbol(),1440,5,0)/mypoint;
double atrtp=iATR(Symbol(),0,VolatilyPeriod,0)/mypoint;


if(BarCount!=Bars){
   TradePerBar = 0;
   setFilter(0, MaxTradePerPosition);
   if(UseAtrMod){
      for (int k1=0;k1<101;k1++){
         arrma[k1]=iMA(Symbol(),0,VolatilyPeriod,0,0,PRICE_MEDIAN,k1);
         arrstd[k1]=iStdDev(Symbol(),0,VolatilyPeriod,0,0,PRICE_MEDIAN,k1);
         arratr[k1]=iCustom(Symbol(),0,"ATR Mod",VolatilyPeriod,0,0,k1);
      }
   }else{
      for (int k=0;k<101;k++){
         arrma[k]=iMA(Symbol(),0,VolatilyPeriod,0,0,PRICE_MEDIAN,k);
         arrstd[k]=iStdDev(Symbol(),0,VolatilyPeriod,0,0,PRICE_MEDIAN,k);
         arratr[k]=iATR(Symbol(),0,VolatilyPeriod,k);
      }
  }
   BarCount=Bars;
}

if(StopLoss<=0) {
   Comment(" EA is not working, your stoploss less or equal to 0");
   return;
}


CloseLossOrder(Magic,OP_BUY,StopLoss*(-1));
CloseLossOrder(Magic,OP_SELL,StopLoss*(-1));
if(isTrailing){
//in case trailing function fail to modify order but we have record our last stoploss
   if(VirtualStopBuy>0&&Bid<VirtualStopBuy){
      ForceCloseAll(Magic,OP_BUY,Green);
      VirtualStopBuy=0; 
   }
   if(VirtualStopSell>0&&Ask>VirtualStopSell){
      ForceCloseAll(Magic,OP_SELL,Green);
      VirtualStopSell=0;  
   }
}
mycomment();
if(SecureMyEquityTarget&&EquityTarget>0&&AccountEquity()>=EquityTarget){
   ForceCloseAll(Magic,OP_BUY,Green);
   ForceCloseAll(Magic,OP_SELL,Green);
   setSell(0);
   setBuy(0);
}
int tkt=0;
double speed3=iCustom(Symbol(),0,"CK_Speed",5,50,0,1);
double speed4=iCustom(Symbol(),0,"CK_Speed",5,50,0,0);
  oneStopLoop();
 tkt= GetCloseCommand(High[1], Low[1],speed3, speed4, Tradetime());
switch (tkt){
case 0:break;
case 1:case1=case1+CloseByTiket(1);break;
case 2:case2=case2+CloseByTiket(1);break;
case 11:ForceCloseAll(Magic,OP_SELL,DarkGreen);case11++;break;

case 22:ForceCloseAll(Magic,OP_BUY,DarkGreen);case22++;break;
case 111:ForceCloseAll(Magic,OP_SELL,Indigo);case111++;break;
case 110:case110=case110+CloseByTiket(1);break;
case 222:ForceCloseAll(Magic,OP_BUY,Indigo);case222++;break;
case 220:case220=case220+CloseByTiket(1);break;
case 2222:ForceCloseAll(Magic,OP_BUY,Maroon);case2222++;break;
case 1111:ForceCloseAll(Magic,OP_SELL,Maroon);case1111++;break;
case 22222:case22222=case22222+CloseByTiket(1);break;
case 22220:ForceCloseAll(Magic,OP_BUY,Violet);case22220++;break;
case 11111:case11111=case11111+CloseByTiket(1);break;
case 11110:ForceCloseAll(Magic,OP_SELL,Violet);case11110++;break;
case 111111:ForceCloseAll(Magic,OP_SELL,Aqua);case111111++;break;
case 222222:ForceCloseAll(Magic,OP_BUY,Aqua);case222222++;break;
case 33:case33=case33+CloseByTiket(1);break;
case 44:case44=case44+CloseByTiket(1);break;
case 55:case55=case55+CloseByTiket(1);break;
case 66:case66=case66+CloseByTiket(1);break;
case 333:case333=case333+CloseByTiket(1);break;
case 444:case444=case444+CloseByTiket(1);break;
case 555:case555=case555+CloseByTiket(1);break;
case 666:case666=case666+CloseByTiket(1);break;

case 3333:ForceCloseAll(Magic,OP_BUY,White);case3333++;break;
case 4444:case4444=case4444+CloseByTiket(1);break;
case 5555:ForceCloseAll(Magic,OP_BUY,Snow);case5555++;break;
case 6666:case6666=case6666+CloseByTiket(1);break;

default:break;
//Print("tkt",tkt);  
}

if(Hour()==CloseHour){
   if(Minute()>30){
      if(TotalOrder(Magic,OP_BUY)<1)setBuy(0);
      if(TotalOrder(Magic,OP_SELL)<1)setSell(0);
   }
}
 
if(Tradetime()==0){
   
   setBuy(1);
   setSell(1);
   setBuy2(1);
   setSell2(1);
   /*
      Apply exit strategy if trading time has been passed
   */
  if(Close[0]>iMA(Symbol(),0,VolatilyPeriod,0,0,PRICE_MEDIAN,0)&&wpr1<-80&&TotalProfit(Magic,OP_SELL)>=(-5))CloseProfitOrder(Magic,OP_SELL,-5,Period()*6,30000000);//we shoud make profit just after price accross ma
  if(Close[0]<iMA(Symbol(),0,VolatilyPeriod,0,0,PRICE_MEDIAN,0)&&wpr1>-20&&TotalProfit(Magic,OP_BUY)>=(-5))CloseProfitOrder(Magic,OP_BUY,-5,Period()*6,30000000);
 
}else{
   updateFilter();
  /*
  You can add specific exit strategies during trading time
  */
  
}
/*
Trailing Stop/loss
*/

double newsl=0;
if(isTrailing){
   newsl=TrailingStop(OP_BUY,speed3,speed4);//just trail when volatility increase
   if(newsl>0)Trail(Magic,OP_BUY,newsl);
   newsl=TrailingStop(OP_SELL,speed3,speed4);
   if(newsl>0)Trail(Magic,OP_SELL,newsl); 
}
 
  //////////////////////////////// //////////////////////////////////////////////////////////////////////////////////
   if (Tradetime()==1){
     if(AccountFreeMarginCheck(Symbol(),OP_BUY,GetLots(OP_BUY))<=0 || GetLastError()==134)  {
                 Print("Not Enough Money ");
                 return(0);
      }  
      if(dailyatr>=MaxDayAtr){
         return;
      }
   int Ticket=0;
      double jual=0;
      oneStopLoop();
      jual=executeOrder(1);
     if(jual>0&&TradePerBar<MaxTradePerPosition&&TotalOrder(Magic,OP_SELL)<MaxTradePerPosition){
     if(!AllowHedge && TotalOrder(Magic,OP_BUY)>0)return;
            Ticket = OrderSend(Symbol(),OP_SELL,GetLots(OP_SELL),Bid,Slippage,0,0,"Volatily Scalp VS_EURCROSS"+Symbol(),Magic,0,Red); 
            Sleep(3000);
              if (Ticket > 0&&StopLoss>=stoplevel) {
                     if(OrderSelect(Ticket,SELECT_BY_TICKET,MODE_TRADES)){
                        OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+StopLoss*mypoint,OrderTakeProfit(),0,Red);
                     }
                     VirtualStopSell=0;
                     TradePerBar++;
                     setFilter(TradePerBar, MaxTradePerPosition);
                      setBuy2(1);
                      PlaySound("alert.wav");
                     return;
               }
    }
    double beli=0;
    oneStopLoop();
    beli=executeOrder(0);
    if(beli>0&&TradePerBar<MaxTradePerPosition&&TotalOrder(Magic,OP_BUY)<MaxTradePerPosition){
    if(!AllowHedge && TotalOrder(Magic,OP_SELL)>0)return;
      Ticket = OrderSend(Symbol(),OP_BUY,GetLots(OP_BUY),Ask,Slippage,0, 0,"Volatily Scalp VS_EURCROSS"+Symbol(),Magic,0,Blue); 
      Sleep(3000);
                  if (Ticket>0&&StopLoss>=stoplevel) {
                     if(OrderSelect(Ticket,SELECT_BY_TICKET,MODE_TRADES)){
                        OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-StopLoss*mypoint,OrderTakeProfit(),0,Red);
                     }
                     VirtualStopBuy=0;
                     TradePerBar++;
                     setFilter(TradePerBar, MaxTradePerPosition);
                     setSell2(1);
                     PlaySound("alert.wav");
                   }
     }
       
    }
 /////////////////////locking funtion
 //oneStopLoop();
  return(0);
} 

//----------------------------------------------------------------------------- 

//----------------------------------------------------------------------------- 

//----------------------------------------------------------------------------- 
/*
void ForceCloseAll(int magic, int cmd,color warna) 
Close all order by magic number and order type
int magic= magic number
int cmd=OP_BUY or OP_SELL
color warna=For debugging purpose, sending different color to track the caller
*/
void ForceCloseAll(int magic, int cmd,color warna) 
{ 
   for (int cnt = OrdersTotal()-1 ; cnt >= 0; cnt--) 
   { 
      OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES); 
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == magic ) 
      { 
            if(OrderType()==cmd)  {
               OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(OrderClosePrice(),Digits),3,warna); 
               Sleep(1000);
             }
           
      } 
   } 
 
}
//----------------------------------------------------------------------------- 
int Tradetime() 
{
   int TradingTime=0;
  if(OpenHour>CloseHour){
     if (Hour() <= CloseHour || Hour() >= OpenHour)TradingTime=1;
   }
   if(OpenHour<CloseHour){
      if(Hour()>=OpenHour&&Hour()<=CloseHour)TradingTime=1;
   }
   if(OpenHour==CloseHour){
      if(Hour()==OpenHour)TradingTime=1;
   }
   if (DayOfWeek() >= 5 && Hour() >18)TradingTime=0;//No friday trade
   if  (DayOfWeek()==1&&Hour()<MondayStart)TradingTime=0;//No trade for first 2 hours on Monday
   if(DayOfYear()<7)TradingTime=0;//No Trade First week of Year 
   if(Month()==12&&Day()>20)TradingTime=0;//No trade after 20 December
   return(TradingTime); 
}
//----------------------------------------------------------------------------- 

double GetLots(int cmd) 
{
   double lots,MD,RM,FMM,MinLots,LotSize; int lotsdigit;
   LotSize = MarketInfo(Symbol(), MODE_LOTSIZE);
   MD = NormalizeDouble(MarketInfo(Symbol(), MODE_LOTSTEP), 2); 
   RM = NormalizeDouble(MarketInfo(Symbol(), MODE_MARGINREQUIRED), 4);
   FMM = (RM+5)*100;
   if(Margin>100)Margin=100;
   double Capital=AccountFreeMargin()*(Margin/100);
   if(LotsDigit==0)
   {
      if (MD<0.1) lotsdigit=2;
      else lotsdigit=1;
      LotsDigit=lotsdigit;
   }
   //if (MM==true) lots = NormalizeDouble((AccountFreeMargin()*Risk/LotSize)/MaxTradePerPosition,LotsDigit);
   if (MM==true){ lots = NormalizeDouble((Capital*Risk/LotSize),LotsDigit);
      if(Marti_MM) lots=(lots*(10*(TotalOrder(Magic,cmd)+1)))/100;
      else lots=lots/MaxTradePerPosition;
   }  else lots=Lots;
   MinLots=NormalizeDouble(MarketInfo(Symbol(),MODE_MINLOT),LotsDigit);
   double MaxLots =NormalizeDouble(MarketInfo(Symbol(),MODE_MAXLOT),LotsDigit);   
   lots=lots-(MathMod(lots,MarketInfo(Symbol(),MODE_LOTSTEP)));
   if (lots < MinLots) lots = MinLots;  
   if (lots > MaxLots) lots = MaxLots;
        
   return (lots);      
}
//----------------------------------------------------------------------------- 

//----------------------------------------------------------------------------- 

//----------------------------------------------------------------------------- 
/*
   bool CloseProfitOrder(int magic, int cmd, int target, double diff, double diff2){
   Close open position buy specifying :
   int magic= magicn umber
   int cmd= OP_BUY or OP_SELL
   int target= Target for profit in pip
   double diff=Minimum Minute in Market
   double diff2=Maximum Minute in Market
   bool return value
   
*/
bool CloseProfitOrder(int magic, int cmd, int target, double diff, double diff2){
   bool result=false;
   int todelete=0;
   for(int i=OrdersTotal()-1;i>=0;i--){
   int profit=0;
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
         if(OrderType()==cmd&&OrderMagicNumber()==magic&&OrderSymbol()==Symbol()){
            if(OrderType()==OP_BUY){
               profit=(OrderClosePrice()-OrderOpenPrice())/mypoint;
             }
            if(OrderType()==OP_SELL){
               profit=(OrderOpenPrice()-OrderClosePrice())/mypoint;
             }
            if(profit>=target&& (TimeCurrent()-OrderOpenTime())>=diff*60&&(TimeCurrent()-OrderOpenTime())<=diff2*60){
               result=OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(OrderClosePrice(),Digits),3,CLR_NONE);
                 
            }
            
         }
      }
   }
   return(result);
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/*
   bool CloseLossOrder(int magic, int cmd, int loss){
   Close open position buy specifying :
   int magic= magicn umber
   int cmd= OP_BUY or OP_SELL
   int target= Target for profit in pip
   double diff=Minimum Minute in Market
   double diff2=Maximum Minute in Market
   bool return value
   
*/
bool CloseLossOrder(int magic, int cmd, int loss){
   bool result=false;
   int todelete=0;
   int profit=0;
   for(int i=OrdersTotal()-1;i>=0;i--){
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
         if(OrderType()==cmd&&OrderMagicNumber()==magic&&OrderSymbol()==Symbol()){
            if(OrderType()==OP_BUY){
               profit=(OrderClosePrice()-OrderOpenPrice())/mypoint;
             }
            if(OrderType()==OP_SELL){
               profit=(OrderOpenPrice()-OrderClosePrice())/mypoint;
             }
            if(profit<=loss){
               result=OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(OrderClosePrice(),Digits),3,CLR_NONE);
                 
            }
            
         }
      }
   }
   return(result);
}
////////////////////////////////////////////////////////////////////////////////////////////////
/*
   int TotalOrder(int magic,int cmd){
   Count number of trade by it's magic number and order type
   int magic= magicn umber
   int cmd= OP_BUY or OP_SELL
   Retun Number of trades by magic number and order type
   
*/

int TotalOrder(int magic,int cmd){
   int result=0;
   
   for(int cnt=OrdersTotal()-1;cnt>=0;cnt--)
        {
         OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
         if (OrderSymbol()==Symbol() && OrderMagicNumber()==magic)
           {
            if(cmd==OrderType()){
               result++;
            }
            
           }
         }
  return(result);   
}
//---------------------------------------------------------------------------------//
/*
void Trail(int magic, int cmd,double newsl){
  Modify open order by it's magic number and order type
  int magic= magicn umber
   int cmd= OP_BUY or OP_SELL
   double new sl= new stoploss value, however the distance between current price and new stop not verified
   
*/
void Trail(int magic, int cmd,double newsl){
       for(int cnt=OrdersTotal()-1;cnt>=0;cnt--)
        {
         OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
         if (OrderSymbol()==Symbol() && OrderMagicNumber()==magic&&OrderType()==cmd)
           {
            if(cmd==OP_BUY){
               if(NormalizeDouble(OrderStopLoss(),Digits)<NormalizeDouble(newsl,Digits)){
                     OrderModify(OrderTicket(),OrderOpenPrice(),newsl,OrderTakeProfit(),0,Gold);
                     VirtualStopBuy=newsl;
               }
               Sleep(1000);
            }
            if(cmd==OP_SELL){
               if(NormalizeDouble(OrderStopLoss(),Digits)>NormalizeDouble(newsl,Digits)||OrderStopLoss()==0){
                  OrderModify(OrderTicket(),OrderOpenPrice(),newsl,OrderTakeProfit(),0,Gold);
                  VirtualStopSell=newsl;
               }
               Sleep(1000);
            }
           }
         }
 
}
/*
All information needed by volatily.dll sended here
*/
void oneStopLoop(){

int            BUY_OpenPosition     = 0;


ArrayInitialize(buys,0);
ArrayInitialize(sells,0);
ArrayInitialize(closes,0);
ArrayInitialize(opens,0);
ArrayInitialize(ot,0);
ArrayInitialize(closes2,0);
ArrayInitialize(opens2,0);
ArrayInitialize(ot2,0);
   int            SELL_OpenPosition    = 0;
   int            TOTAL_OpenPosition   = 0;
   int            Ticket               = -1;
   int            cnt                  = 0;
   double         Last_BUY_OpenPrice   =0;
   double         Last_SELL_OpenPrice   =0;
   double         tpb=0;
   double         tps=0;
   int k=0;
   int p=1;
   for (cnt = OrdersTotal()-1; cnt >=0; cnt--) 
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magic ){
         TOTAL_OpenPosition++;
         if (OrderType() == OP_BUY) {
         if( BUY_OpenPosition>3)continue;//max order perposition that can be managed are 4
            BUY_OpenPosition++;
            buys[BUY_OpenPosition-1]=OrderTicket();
            opens[BUY_OpenPosition-1]=OrderOpenPrice();
            closes[BUY_OpenPosition-1]=OrderClosePrice();
            ot[BUY_OpenPosition-1]=OrderOpenTime();
         }
         if (OrderType() == OP_SELL){
         if( SELL_OpenPosition>3)continue;
            SELL_OpenPosition++;
                sells[SELL_OpenPosition-1]=OrderTicket();
            opens2[SELL_OpenPosition-1]=OrderOpenPrice();
            closes2[SELL_OpenPosition-1]=OrderClosePrice();
            ot2[SELL_OpenPosition-1]=OrderOpenTime();
            
         }
        
      }
   }
 
setOrder( p,sells,  opens2, closes2,  ot2, SELL_OpenPosition);
 setOrder( k,buys,  opens, closes,  ot, BUY_OpenPosition);
 arrma[0]=iMA(Symbol(),0,VolatilyPeriod,0,0,PRICE_MEDIAN,0);
arrstd[0]=iStdDev(Symbol(),0,VolatilyPeriod,0,0,PRICE_MEDIAN,0);
if(UseAtrMod){
  arratr[0]= iCustom(Symbol(),0,"ATR Mod",VolatilyPeriod,0,0,0);
}else{
   
   arratr[0]=iATR(Symbol(),0,VolatilyPeriod,0);
}

setHarga(Bid, Ask, spread, mypoint, TimeCurrent(), Period(),  iWPR(Symbol(),1,VolatilyPeriod,0),NormalSpread,MyOwnTarget);
calculateIndi(arrma,arrstd,arratr);
 
}
int CloseByTiket(int tiket){
bool ok1,ok2,ok3,ok4=false;
if (OrderSelect(GetTiket1(),SELECT_BY_TICKET,MODE_TRADES)){
  if(OrderMagicNumber()==Magic&&OrderSymbol()==Symbol()) ok1= OrderClose(GetTiket1(),OrderLots(),NormalizeDouble(OrderClosePrice(),Digits),Slippage,CLR_NONE);
}
if (OrderSelect(GetTiket2(),SELECT_BY_TICKET,MODE_TRADES)){
  if(OrderMagicNumber()==Magic&&OrderSymbol()==Symbol()) ok2= OrderClose(GetTiket2(),OrderLots(),NormalizeDouble(OrderClosePrice(),Digits),Slippage,CLR_NONE);
}
if (OrderSelect(GetTiket3(),SELECT_BY_TICKET,MODE_TRADES)){
  if(OrderMagicNumber()==Magic&&OrderSymbol()==Symbol()) ok3= OrderClose(GetTiket3(),OrderLots(),NormalizeDouble(OrderClosePrice(),Digits),Slippage,CLR_NONE);
}
if (OrderSelect(GetTiket4(),SELECT_BY_TICKET,MODE_TRADES)){
  if(OrderMagicNumber()==Magic&&OrderSymbol()==Symbol()) ok4= OrderClose(GetTiket4(),OrderLots(),NormalizeDouble(OrderClosePrice(),Digits),Slippage,CLR_NONE);
}
return(ok1+ok2+ok3+ok4);
}

/*
My advertise, please do not change it.
*/
void mycomment(){

 string str1 = "\n" +
             "Thank You fou using Volatily Scalp System" + "\n" + 
             "Find any update and explanation on the blog Volatily-Scalp.blogspot.com"+"\n" + 
             "This EA will expired at " + TimeToStr(a,TIME_DATE)+"\n" + 
             "And will be updated periocally a week before expiring" + "\n" + 
             " \\  //   ||     ||      /\    |||| || ||   \\//"+"\n"+
             "  \\//  ||  ||   ||     /||\    ||  || ||    ||"+"\n"+
             "   \/     ||     ||||  //  \\   ||  || ||||  ||"+"\n"+
             "\n"+
             "Time Configuration : OpenHour="+OpenHour+ " CloseHour= "+CloseHour+"  \n"+
             "Current Time Server: "+ TimeToStr(TimeCurrent(),TIME_MINUTES)+" \n"+
             "Current Local Time : "+ TimeToStr(TimeLocal(),TIME_MINUTES)+" \n"+
             " \n"+
             " Account Information : \n"+
             " Account Balance     :" + DoubleToStr (AccountBalance(),2)+"\n"+
             " Account Equity      :" + DoubleToStr (AccountEquity(),2)+"\n"+
             " Market Spread       :"+DoubleToStr(spread,2);
             
            
Comment(str1);
}
/*
int TotalProfit(int magic,int cmd){
Calculate current profit/loss in pips value
int magic=magic number
int cmd =OP_BUY or OP_SELL
Return amount unrealized profit/loss in pips
*/
double TotalProfit(int magic,int cmd){
   double result=0;
   double harga1;
   for(int cnt=OrdersTotal()-1;cnt>=0;cnt--)
        {
         OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
         if (OrderSymbol()==Symbol() && OrderMagicNumber()==magic)
           {
            if(cmd==OP_BUY&&cmd==OrderType()){
               result=result+((OrderClosePrice()-OrderOpenPrice())/mypoint);
            }
            if(cmd==OP_SELL&&cmd==OrderType()){
               result=result+((OrderOpenPrice()-OrderClosePrice())/mypoint);
            }  
           }
         }
  return(result);   
}


double NetProfit(int magic,int cmd){
   double result=0;
   double harga1;
   for(int cnt=OrdersTotal()-1;cnt>=0;cnt--)
        {
         OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
         if (OrderSymbol()==Symbol() && OrderMagicNumber()==magic)
           {
            if(cmd==OrderType()){
               result=result+((OrderProfit()-MathAbs(OrderCommission())));
            }
            
           }
         }
  return(result);   
}